<?php /*

Copyright 2005 Jonathan Davis (stickman@rageagainst.net)
This file is part of Statfink.

Statfink is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Statfink is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Statfink; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/?>
<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Saving Configuration Files</title>
</head>
<body>
<?php
include("version.php");
error_reporting(1);
foreach ($_POST as $key => $value) {
	if($key == 'fullurl' || $key == 'dbhost' || $key == 'dbname' || $key == 'dbuser' || $key == 'dbpass' || $key == 'tzname' || $key == 'ftp_server' || $key == 'ftp_user_name' || $key == 'ftp_user_pass')
	{
		if($value == ""){
			echo "Error: You left the ".$key." box blank!  Use your browser's back button to correct this!<br></body></html>";
			die;
		}
	}elseif($key != 'ftp_dir'){
        if(!is_numeric($value) && $key != 'ftp_enabled'){
			echo "Error: The ".$key." box is not numeric!  Use your browser's back button to correct this!<br></body></html>";
			die;
		}
	}
}

if (!ini_get('register_globals')) {//grabs the many, many post variables.
    $number = extract($_POST, EXTR_OVERWRITE);
}

$miscconfigname = 'config_misc.php';
if (!$miscconfig = fopen($miscconfigname, 'a')) {
        echo "Cannot open file ($miscconfigname)";
        exit;
}

//building the config_misc file
$misccontent =
"<?php\n".
"$"."fullurl = \"".$fullurl."\";\n".
"$"."timezone = ".$timezone.";\n".
"$"."tzname = \"".$tzname."\";\n".
"$"."dbhost = \"".$dbhost."\";\n".
"$"."dbname = \"".$dbname."\";\n".
"$"."dbuser = \"".$dbuser."\";\n".
"$"."dbpass = \"".$dbpass."\";\n".
"$"."refreshrate = \"".$refreshrate."\";\n".
"$"."ftp_user_name = \"".$ftp_user_name."\";\n".
"$"."ftp_user_pass = \"".$ftp_user_pass."\";\n".
"$"."ftp_server = \"".$ftp_server."\";\n".
"$"."ftp_enabled = \"".$ftp_enabled."\";\n".
"$"."ftp_dir = \"".$ftp_dir."\";\n".
"?>";


//FTP Initialize Host+
if( isset($ftp_enabled) && $ftp_enabled == true )
   {
   		// set up basic connection
	$conn_id = ftp_connect($ftp_server);

	// login with username and password
	$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);
    ftp_pasv ($conn_id, true) ;//enable passive mode
	// check connection
	if ((!$conn_id) || (!$login_result))
	{
        echo "FTP connection has failed!";
        echo "Attempted to connect to $ftp_server for user $ftp_user_name"."<br>\n";
	}
	else
	{
        echo "Connected to $ftp_server, for user $ftp_user_name"."<br>\n";
	}
	if($ftp_dir != ""){
		
		$gooddir = ftp_chdir($conn_id, $ftp_dir);
		if ($gooddir != true)
		{
    	    echo "FTP directory change has failed!";
    	    echo " Failed to change directory on FTP server to ".$ftp_dir.". Check your FTP directory setting on the config page.<br>\n";
		}
	}
	
	$db = mysql_connect($dbhost, $dbuser, $dbpass);
	mysql_select_db($dbname,$db);
	$query6 = "SELECT * FROM leagues";
	$result6 = mysql_query($query6, $db);
	
	// try to create the league directories on the remote host
	if($therisarow = mysql_fetch_array($result6)){
		do{
		    if (ftp_mkdir($conn_id, $therisarow["leaguename"])) {
				echo "successfully created ".$therisarow["leaguename"]." on the ftp server\n<br>";
			} else {
//				echo "There was a problem while creating ".$therisarow["leaguename"]." on the ftp server.  If it already exists, this is ok.\n<br>";
			}
		}while($therisarow = mysql_fetch_array($result6));
	}
	//start building a static index.php file for the ftp host
	$indexcontent='<!doctype html public "-//W3C//DTD HTML 4.0 //EN"><html><head><title>Welcome to StatFink!</title></head><body><img src="statfinklogowhite.png"><h2>Choose your league:</h2>';
	$db = mysql_connect($dbhost, $dbuser, $dbpass);
	mysql_select_db($dbname,$db);
	$query6 = "SELECT * FROM leagues WHERE active = 1";
	$result6 = mysql_query($query6, $db);
	if($therisarow = mysql_fetch_array($result6)){
		do{
		$indexcontent.='<a href="ajax.php?league='.$therisarow["leaguename"].'" target="_blank"><b>'.$therisarow["leaguename"].'</b></a> Dynamic "AJAX" Statfink interface.<br>';
		$indexcontent.='<a href="'.$therisarow["leaguename"].'/index.htm" target="_blank">'.$therisarow["leaguename"].'</a> Classic static Statfink interface.<br><br>';
		}while($therisarow = mysql_fetch_array($result6));
	}else{
		echo 'This server has no leagues configured yet!  Your ftp server won\'t have a home page until a league is configured.';
	}
	$indexcontent.='<br>The "AJAX" interface is recommended, as it is much easier to use, looks much nicer and has more features.<Br>The classic interface is still around for browsers that don\'t support javascript(like most cellphone browsers) or in case something is broken in the new interface. ';
	$indexcontent.='</body></html>';
	//ok, done making the content for static index, now dump it to a file...
   	
	$indexstaticname = '../../indexstatic.php';
	if (!$indexstatic = fopen($indexstaticname, 'a')) {
        echo "Cannot open file ($indexstaticname)";
        exit;
	}
   ftruncate($indexstatic, 0);
	if (fwrite($indexstatic, $indexcontent) === FALSE) { //output to file
    echo "OHNOS! Cannot write to file ($indexstaticname)";
    exit;
   }else{
   		echo "<br>Success, finished with file ($indexstaticname)";
	}
	//upload the static index.php we just made
	$source_file = '../../indexstatic.php';
	$destination_file = 'index.php';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);
	
	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	//upload version tag file
   	if (!$versionfile = fopen($version.".txt", 'a')) {
        echo "Cannot open file ($versionfile)";
        exit;
	}
   ftruncate($versionfile, 0);
	if (fwrite($versionfile, $version) === FALSE) { //output to file
    echo "OHNOS! Cannot write to file ($versionfile)";
    exit;
   }else{
   		echo "<br>Success, finished with file ($versionfile)";
	}
	//upload the static index.php we just made
	$source_file = '../../indexstatic.php';
	$destination_file = 'index.php';
	$upload = ftp_put($conn_id, $version.".txt", $version.".txt", FTP_ASCII);
	
	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload ".$version.".txt<br>\n";
	}
	else
	{
		echo "Uploaded ".$version.".txt<br>\n";
	}
	
	//upload the datetime.js
	$source_file = '../../datetime.js';
	$destination_file = 'datetime.js';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
   	//upload the tinyxmldom.js
	$source_file = '../../tinyxmldom.js';
	$destination_file = 'tinyxmldom.js';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
    //upload the white backgrounded statfink logo
	$source_file = '../../statfinklogowhite.png';
	$destination_file = 'statfinklogowhite.png';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_BINARY);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
    //upload the statfink logo
	$source_file = '../../statfinklogo.png';
	$destination_file = 'statfinklogo.png';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_BINARY);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
   	//upload the ajax.php
	$source_file = '../../ajax.php';
	$destination_file = 'ajax.php';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	//upload the chat.php
	$source_file = '../../chat.php';
	$destination_file = 'chat.php';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	//upload the chat.php
	$source_file = '../../w.php';
	$destination_file = 'w.php';
	$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_ASCII);

	if (!$upload)
	{
		echo "FTP upload has failed!"."  Attempted to upload $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	else
	{
		echo "Uploaded $source_file to $ftp_server as $destination_file"."<br>\n";
	}
	
	$srcroot = "../../";
	chdir($srcroot);
	$srcroot = getcwd()."/";
	$ftproot = ftp_pwd($conn_id)."/";
	ftpRec("themes/"); //upload the whole themes directory
	// close the FTP stream
	ftp_close($conn_id);
}
function ftpRec ($srcrela)
{
    global $ftproot;
	global $srcroot;
	global $conn_id;
    global $login_result;
               
    // enter the local directory to be recursed through
    chdir($srcroot.$srcrela);
   
    // check if the directory exists & change to it on the destination
    if (!ftp_chdir($conn_id,$ftproot.$srcrela))
    {
        // remote directory doesn't exist so create & enter it
           ftp_mkdir($conn_id,$ftproot.$srcrela);
           ftp_chdir($conn_id,$ftproot.$srcrela);
    }

    if ($handle = opendir("."))
    {
       while (false !== ($fil = readdir($handle)))
       {
           if ($fil != "." && $fil != "..")   
           {
               // check if it's a file or directory
               if (!is_dir($fil))
               {   
                   // it's a file so upload it
					echo "Uploaded ".$fil."<br>";
                   ftp_put($conn_id, $ftproot.$srcrela.$fil, $fil, FTP_BINARY);
                }
                else
                {
                    // it's a directory so recurse through it
                    ftpRec ($srcrela.$fil."/");
                	chdir ("../");
                }
          }
      }
      closedir($handle);
    }   
}
//FTP Initialize Host-


ftruncate($miscconfig, 0);
	if (fwrite($miscconfig, $misccontent) === FALSE) { //output to file
    echo "OHNOS! Cannot write to file ($miscconfigname)";
    exit;
   }else{
   		echo "<br>Success, finished with file ($miscconfigname)";
	}


	echo '<br><br><font size="+1">Step 2 of initial configuration: If you\'re configuring statfink for the first time, make sure you <a href="installdb.php">click this link</a> to create the correct tables in your database!</font>';
	echo '<br><br>If you want to go back to the main config page, <a href="index.php">click here</a>';
	echo '<br><br>If you just changed your existing settings, you\'re all done!  <a href="../">Click here</a> to get back to the helm page!';
?>
</body>
</html>
