<?php /*

Copyright 2005 Jonathan Davis (stickman@rageagainst.net)
This file is part of Statfink.

Statfink is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Statfink is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Statfink; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
error_reporting(1);
include 'config/version.php';
include 'config/config_misc.php';
$oldftp = 0;
if($dbuser != ""){
	$db = mysql_connect($dbhost, $dbuser, $dbpass);
	mysql_select_db($dbname,$db);
	$configured = 1;
	$result = mysql_query('SHOW COLUMNS FROM nflgames like "homescore"');
	if (mysql_num_rows($result) == 0) {
 		$olddb = 1;
	}else{
		$olddb = 0;
	}
}else{
	$configured = 0;
}
if( isset($ftp_enabled) && $ftp_enabled == true ){//Lets make sure the ftp location is up to date
   	// set up basic connection
	$conn_id = ftp_connect($ftp_server);

	// login with username and password
	$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);
    ftp_pasv($conn_id, true) ;//enable passive mode
	// check connection
	if ((!$conn_id) || (!$login_result))
	{
        echo "FTP connection has failed!";
        echo "Attempted to connect to $ftp_server for user $ftp_user_name"."<br>\n";
	}
	if($ftp_dir != ""){
		
		$gooddir = ftp_chdir($conn_id, $ftp_dir);
		if ($gooddir != true)
		{
    	    echo "FTP directory change has failed!";
    	    echo " Failed to change directory on FTP server to ".$ftp_dir.". Check your FTP directory setting on the config page.<br>\n";
		}
	}
	if (!ftp_get($conn_id, "versiontest.txt", $version.".txt", FTP_ASCII)){
		$oldftp = 1;
	}else{
		$oldftp = 0;
	}
	// close the FTP stream
	ftp_close($conn_id);
}
?>
<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
	   <script type="text/javascript" src="../helm/datetime.js"></script>
       <title>The Helm</title>
</head>
<SCRIPT TYPE="text/javascript">
<!--
var lastYahooUpdate = 0;
var bUpdating = false;
var bCompleteRestart = <?php if( !array_key_exists("completerestart", $_GET ) || $_GET['completerestart'] == "true" ){ echo "true;"; } else { echo "false;"; } ?>


function restartweek()
{
	frames['tracker'].location.href = "restartweek.php";
}

function resumetracking()
{
	frames['tracker'].location.href = "tracker.php";
}

function doaction( action )
{
	if( action == "restartweek" )
	{
		restartweek();
	}
	else if( action == "resumetracking" )
	{
		resumetracking();
	}
	else if( action == "none" )
	{
		//do nothing
	}
}

function nflgamesupdate( nextaction )
{
	url =  "nflgamesupdate.php";
	url += "?nflweek=" + document.weekform.nflweek.options[document.weekform.nflweek.selectedIndex].value; 
	url += "&nextaction=" + nextaction;
	
    parent.info.location.href = url;
}

function yahooupdate( nextaction )
{
	url = "league.php?week=" + document.weekform.nflweek.options[document.weekform.nflweek.selectedIndex].value + "&nextaction=" + nextaction;
	var d = new Date();
	lastYahooUpdate = d.getTime();
    frames['teams'].location.href = url;
}

function pulldata( nextaction )
{
	yahooupdate( nextaction );
	nflgamesupdate( "none" );
}

function stopnow()
{
	if(window.stop)
      window.stop();
	else
      document.execCommand("Stop");

}

function rollover(pageImageName)
{
    document.getElementById(pageImageName).src = "images/" + pageImageName + "roll.gif";
}

function rollout(pageImageName)
{
    document.getElementById(pageImageName).src = "images/" + pageImageName + ".gif";
}


//-->
</SCRIPT>
<body bgcolor="#EEEEEE" <?php if( array_key_exists("autoload", $_GET ) && $_GET['autoload'] == "true" ){ echo "onload=\"pulldata('restartweek')\""; } ?>>
<table width=700 cellpadding=0>
	<tr>
		<td colspan=3 align="center"><h1>The Helm <?php echo $version; ?></h1>
		<?php
			if(!$configured){
				echo "<H2>Please use the configuration link below to configure this server!</H2>";
			}elseif($olddb){
				echo '<H2>Your database is outdated! <a href="config/upgradedb.php" target="_blank">Click here to upgrade it!</a><br>Reload this page after you\'re done.</H2>';
			}elseif($oldftp){
				echo '<H2>Your FTP server has old files! <a href="config/" target="_blank">Go here then "Save Settings" to fix!</a><br>Reload this page after you\'re done.</H2>';
			}
		?>
		</td>
	</tr>
	<tr>
		<td width=200 hight=50 valign="top"><a href="javascript:pulldata('none')" onMouseOver ="rollover('fantasy')" onMouseOut ="rollout('fantasy')"><img src="images/fantasy.gif" name="fantasy" id="fantasy" border=0 ></a></td>
		<td width=200 hight=50 valign="bottom"><a href="javascript:restartweek()" onMouseOver ="rollover('start')" onMouseOut ="rollout('start')"><img src="images/start.gif" name="start" id="start" border=0></a></td>
		<td rowspan=5 valign="bottom"><iframe name="tracker" height=435 width=300 src="http://statfink.sourceforge.net/info.php?v=<?php echo $version; ?>"></iframe></td>
	</tr>
	<tr>
		<td hight=50 valign="top">
			<form id="weekform" name="weekform" action="nflgamesupdate.php" target="info" method="POST">
				Data to use:&nbsp;
				<select name="nflweek">
					<option value="0">This week</option>
					<option value="1">Week 1</option>
					<option value="2">Week 2</option>
					<option value="3">Week 3</option>
					<option value="4">Week 4</option>
					<option value="5">Week 5</option>
					<option value="6">Week 6</option>
					<option value="7">Week 7</option>
					<option value="8">Week 8</option>
					<option value="9">Week 9</option>
					<option value="10">Week 10</option>
					<option value="11">Week 11</option>
					<option value="12">Week 12</option>
					<option value="13">Week 13</option>
					<option value="14">Week 14</option>
					<option value="15">Week 15</option>
					<option value="16">Week 16</option>
					<option value="17">Week 17</option>
				</select>
				<br>
				<a href="../index.php"  target="_blank"><b>Click here for scores</b></a>
				<br>
				<a href="config/index.php" target="_blank"><b>Statfink Configuration</b></a>
			</form>
		</td>
		<td hight=50 valign="top">
			<a href="javascript:stopnow()" onMouseOver ="rollover('stop')" onMouseOut ="rollout('stop')"><img src="images/stop.gif" name="stop" id="stop" border=0></a>
		</td>
	</tr>
	<tr>
		<td valign="bottom"><iframe id="teams" name="teams" height=300 width=200></iframe></td>
		<td valign="bottom"><iframe id="info" name="info" height=300 width=200></iframe></td>
	</tr>
</table>

</body>
</html>
