<?php
/*

Copyright 2005 Jonathan Davis (stickman@rageagainst.net)
This file is part of Statfink.

Statfink is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Statfink is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Statfink; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/?>
<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Grabbing The Games</title>
</head>
<body>
<?php
if(!ini_set('max_execution_time', 500)){
	echo "Your server won't allow me to change php variables, you may have problems!";
}


$whichweek = $_GET["nflweek"];

require 'config/config_misc.php';
include ("config/globals.php");


$twodarray = importgames($whichweek);
$games = $twodarray[0];
$statuses = $twodarray[1];
$nflgameids = $twodarray[2];
$nflawayteams = $twodarray[3];

$db = mysql_connect($dbhost, $dbuser, $dbpass);
mysql_select_db($dbname,$db);

echo "NFL games loaded:<br>";

$nextaction = $_GET["nextaction"];

for($x = 0; $x < sizeof($games); $x++){
	if(!$games[0]){
		echo "Error: No games have started yet this week";
		break;
	}else{
		if($x == 0)
		{
			//grab id's of games that are already final so we don't have to parse them again.
			if( $nextaction == "restartweek" || $nextaction == "none" )
			{
				$query = "TRUNCATE TABLE nflgames";
				$result = mysql_query($query, $db);
			}
		}
		
		$statusnote = "";

		//If the game is in the future, then store the game time
		// in the start_time column
		if( substr($games[$x], 0, 6) == "future" )
		{
			$gameid = substr($games[$x], 7, strlen($games[$x])-7);
			$teamnames = explode("@", $gameid);
			$hometeamname = $teamnames[1];
			$awayteamname = $teamnames[0];
			$nflarraykey = array_search($awayteamname, $nflawayteams);
			//echo $nflarraykey."<br>";
			$nflgameid = $nflgameids[$nflarraykey]; //locate corresponding nfl.com gameid
			
			//--------------------------------------------------------------------//
			// The following section works with mysql versions >= 4.1             //
			// It is more straight forward, but to be passive to older installs   //
			// of mysql, the old insert/update logic is still used  below.  If    //
			// statfink is ever changed to require mysql 4.1+, change this to use //
			// the "on duplicate key" logic.                                      //
			//--------------------------------------------------------------------//
			//
			//$query = "INSERT INTO nflgames (hometeam, awayteam, status, start_time, status_flag, gameid) ".
			//         "VALUES ('".$hometeamname."', ".
			//                 "'".$awayteamname."', ".
			//                 "'',".
			//                 "from_unixtime(".$statuses[$x]."),".
			//                 $status_flag_future.", ".
			//                 "'".$gameid."')".
			//                 "on duplicate key update status = '', ".
			//                                         "start_time = from_unixtime(".$statuses[$x]."), ".
			//                 						 "status_flag = ".$status_flag_future.", ".
			//                                         "gameid = '".$gameid."'";
			//
			//----------------------------------------------------------//
			// End of "ON DUPLICATE KEY" mysql 4.1+ insert/update logic //
			//----------------------------------------------------------//
			
			//-----------------------------------------------------------//
			// Begin pre-mysql 4.1 insert/update logic (see note above)  //
			//-----------------------------------------------------------//
			
			$query = "Select * from nflgames where hometeam = '".$hometeamname."' and awayteam = '".$awayteamname."'";
			$result = mysql_query($query, $db);
			if($myrow = mysql_fetch_array($result))
			{
				$query = "update nflgames set status      = ''".", ".
											 "start_time  = from_unixtime(".$statuses[$x].")".", ".
											 "status_flag = ".$status_flag_future.", ".
											 "gameid      = '".$gameid."', ".
											 "nflgameid      = '".$nflgameid."' ".
				         "where hometeam = '".$hometeamname."' ".
				           "and awayteam = '".$awayteamname."'";
			}   
			else
			{
				$query = "INSERT INTO nflgames (hometeam, awayteam, status, start_time, status_flag, gameid, nflgameid) ".
				         "VALUES ('".$hometeamname."', ".
				                 "'".$awayteamname."', ".
				                 "'',".
				                 "from_unixtime(".$statuses[$x]."),".
				                 $status_flag_future.", ".
				                 "'".$gameid."', ".
				                 "'".$nflgameid."')";		
			}            
			
			//---------------------------------------//
			// End pre-mysql 4.1 insert/update logic //
			//---------------------------------------//

			$statusnote = " (Future)"; 
		}
		else
		{
			$gameid = $games[$x];
			$teamnames = explode("_", $gameid);
			$teamnames = explode("@", $teamnames[2]);
			$hometeamname = $teamnames[1];
			$awayteamname = $teamnames[0];
			$nflarraykey = array_search($awayteamname, $nflawayteams);
			//echo $nflarraykey."<br>";
			$nflgameid = $nflgameids[$nflarraykey]; //locate corresponding nfl.com gameid
			
			if( $nextaction == "restartweek" || $nextaction == "none" )
			{
				$status_flag_update_value = $status_flag_inprogress;
			}
			else
			{
				$status_flag_update_value = "if(status_flag = ".$status_flag_future.", ".$status_flag_inprogress.", status_flag)";
			}

			//------------------------------------------------------------//
			// Start of "ON DUPLICATE KEY" mysql 4.1+ insert/update logic //
			//------------------------------------------------------------//
			//
			//$query = "INSERT INTO nflgames (hometeam, awayteam, status, status_flag, gameid) ".
			//         "VALUES ('".$hometeamname."', ".
			//                 "'".$awayteamname."', ".
			//                 "'',".
			//                 $status_flag_inprogress.", ".
			//                          "'".$gameid."')".
			//                 "on duplicate key update gameid = '".$gameid."', ".
			//                                          "status_flag = ".$status_flag_update_value;
			//                 
			//----------------------------------------------------------//
			// End of "ON DUPLICATE KEY" mysql 4.1+ insert/update logic //
			//----------------------------------------------------------//			                 

			//-----------------------------------------------------------//
			// Begin pre-mysql 4.1 insert/update logic (see note above)  //
			//-----------------------------------------------------------//
			
			$query = "select * from nflgames where hometeam = '".$hometeamname."' and awayteam = '".$awayteamname."'";
			$result = mysql_query($query, $db);
			if($myrow = mysql_fetch_array($result))
			{
				$query = "update nflgames set status_flag = ".$status_flag_update_value.", ".
											 "gameid      = '".$gameid."', ".
											 "nflgameid      = '".$nflgameid."' ".
				         "where hometeam = '".$hometeamname."' ".
				           "and awayteam = '".$awayteamname."'";
			}   
			else
			{
				$query = "INSERT INTO nflgames (hometeam, awayteam, status, status_flag, gameid, nflgameid) ".
				         "VALUES ('".$hometeamname."', ".
				                 "'".$awayteamname."', ".
				                 "'',".
				                 $status_flag_inprogress.", ".
				                 "'".$gameid."', ".
				                 "'".$nflgameid."')";		
			}            
			
			//---------------------------------------//
			// End pre-mysql 4.1 insert/update logic //
			//---------------------------------------//
		}


		echo $awayteamname."@".$hometeamname.$statusnote."<br>\n";
		//echo $query."<br>";
		$result = mysql_query($query, $db);
		if(mysql_errno($db)){
			echo mysql_errno($db) . ": " . mysql_error($db). "<br>";
		}
	}
}

	//Rewrote this function so that game statuses are also parsed.
	//For games that are in progress, this will consist of the quarter and time left.
	//For games in the future, this will consist of the game day and time
	//For games that have ended, this will be "Final".
	function importgames($whichweek)
	{
		if($whichweek)
		{
			$url = "http://www.sportsline.com/nfl/scoreboard/2008/week".$whichweek;
			$nflurl = "http://www.nfl.com/scores?season=2008&week=Week+".$whichweek;
		}
		else
		{
			$url = "http://www.sportsline.com/nfl/scoreboard";
			$nflurl = "http://www.nfl.com/scores";
		}

		list($protocol, $uri) = split('//', $url);
		//$result = file_get_contents($protocol . '//' . $uri); //grab the main scores page

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec ($ch);
		curl_setopt($ch, CURLOPT_URL, $nflurl);
		$nflresult = curl_exec ($ch);
		curl_close ($ch);
		$start = strpos($result, '<div class=SLTables1><table   width=100% cellpadding=2 cellspacing=1 border=0><tr  height=17 id=head class=bg2 align=right valign=middle><td  class=columnrow align=left width=');
		if(!$start){
			$start = strpos($result, '<div class=SLTables1><table   width=100% cellpadding=2 cellspacing=1 border=0><tr  height=17 id=head class=bg2 align=right valign=middle>');
			$altpage = 1;
		}else{
			$altpage = 0;
		}
		$myi = -1;
		while($start)//parses through sportsline.com pages to grab game IDs and timestamps from there
		{
			$myi++;
			if($altpage){
				$start += 176;
			}else{
				$start += 182;
			}
			
			if( substr($result, $start, 8) == '<script>' )
			{
				$start += 46;
				$end = strpos($result, '</script>', $start) - 2;
				$length = $end - $start;
				$status[] = substr($result, $start, $length);  //Just pass the timestamp.  We will format the date later.
			}
			else
			{
				$end = strpos($result, '</b>', $start);
			    $length = $end - $start;
			    $status[] = substr($result, $start, $length);
			}

			$nextInProgress = strpos($result, '/gamecenter/live/', $start);
			$stemp = $start;
			if($altpage){
				$start = strpos($result, '<div class=SLTables1><table   width=100% cellpadding=2 cellspacing=1 border=0><tr  height=17 id=head class=bg2 align=right valign=middle>', $start);
			}else{
				$start = strpos($result, '<div class=SLTables1><table   width=100% cellpadding=2 cellspacing=1 border=0><tr  height=17 id=head class=bg2 align=right valign=middle><td  class=columnrow align=left width=', $start);
			}
			if( $nextInProgress && (!$start || $nextInProgress < $start ) )
			{
				$nextInProgress += 17;
				$end = strpos($result, '>', $nextInProgress);
				$length = $end - $nextInProgress;
				$matchups[] = substr($result, $nextInProgress, $length);//toss each gameid into an array
			}
			else
			{
				$stemp = strpos($result, '/teams/depth-chart/', $stemp ) + 19;
				$etemp = strpos($result, '"', $stemp );
				$awayTeam = substr( $result, $stemp, $etemp-$stemp );

				$stemp = strpos($result, '/teams/depth-chart/', $stemp ) + 19;
				$etemp = strpos($result, '"', $stemp );
				$homeTeam = substr( $result, $stemp, $etemp-$stemp );

				$matchups[] = "future:".$awayTeam."@".$homeTeam;
			}
		}
		
		$start = strpos($nflresult, '<div class="scoresInfo">');
		while($start)
		{
			$stemp = $start + 24;
			$stemp = strpos($nflresult, '>', $stemp)+1;
			$end = strpos($nflresult, ':', $stemp);
			$length = $end - $stemp;
			$awayteam[] = substr($nflresult, $stemp, $length);// dump in the away team of each game for later identification
			$start = strpos($nflresult, '<a href="/gamecenter?game_id=', $stemp);
			$stemp = $start + 29;
			$end = strpos($nflresult, '&', $stemp);
			$length = $end - $stemp;
			$nflmatchups[] = substr($nflresult, $stemp, $length);//dump in the nfl.com gameid of each game
			$start = strpos($nflresult, '<div class="scoresInfo">', $start);
		}
		$tdarray[] = $matchups;
		$tdarray[] = $status;
		$tdarray[] = $nflmatchups;
		$tdarray[] = $awayteam;//these last 2 are in a different order than the first 2 and will need to be sorted to match

	  	return $tdarray;
	}

?>

	<script language="javascript">
	<!--
	window.parent.doaction("<?php echo $nextaction ?>");
	-->
	</script>

</body>
</html>
